﻿using System;
using System.Linq;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Diagnostics;
using Experior.Core;
using Experior.Core.Assemblies;
using Experior.Catalog.Logistic;
using Microsoft.DirectX;
using Experior.Catalog;

namespace Experior.Plugin.TestPlugin
{
    public class TestPlugin : Core.Plugin
    {

        #region Fields
        private frmSensorIO _sensorIOForm;
        public static Experior.Core.Resources.Icons Icons;
        #endregion

        #region Constructor
        public TestPlugin() : base("TestPlugin")
        {
            Icons = new Experior.Core.Resources.Icons(System.Reflection.Assembly.GetExecutingAssembly());
            if (Experior.Core.Environment.Engine.Physics)
            {
                AddMenuItems();
                Experior.Core.Environment.Scene.OnLoaded += new Core.Environment.Scene.Event(Scene_Loaded);
                _sensorIOForm = new frmSensorIO
                {
                    TabText = "SensorOutputs"
                };
            }
        }
        #endregion

        #region Methods
        void Scene_Loaded()
        {
            if (_sensorIOForm != null)
            {
                _sensorIOForm.startLoading();
            }
        }

        private void AddMenuItems()
        {
            Core.Environment.UI.Toolbar.Button IOButton = new Core.Environment.UI.Toolbar.Button("SensorOutputs", BtnIOToggle_Click)
            {
                Image = Icons.Get(@"Icons.IO"),
                Tooltip = "Show outputs from sensors"
            };

            // add the button to the Model toolbar in a Tab with name "TestPlugin"
            Core.Environment.UI.Toolbar.Add(IOButton, "TestPlugin");
        }

        private void BtnIOToggle_Click(object sender, EventArgs e)
        {
            _sensorIOForm?.Show();
            if (_sensorIOForm != null)
            {
                _sensorIOForm.startLoading();
            }
        }

        public override System.Drawing.Image Logo
        {
            get
            {
                return Icons.Get(@"Icons.Logo.jpg");
            }
        }
        #endregion
    }
}
